﻿using System;
using System.Windows.Forms;
using System.IO;

namespace CuteMP4
{
    public partial class Form_settings : Form
    {
        public Form_settings()
        {
            InitializeComponent();
        }
        private void Form_settings_Load(object sender, EventArgs e)
        {
            textBox_Window_mode.Text = Properties.Settings.Default.AllowsTransparency_FLG.ToString();
            textBox_Stretch_Mode.Text = Properties.Settings.Default.strech_FLG.ToString();
            textBox_Continue.Text = Properties.Settings.Default.continue_FLG.ToString();
            textBox_Button_Visibility.Text = Properties.Settings.Default.init_visibility.ToString();
            textBox_Topmost.Text = Properties.Settings.Default.topmost_FLG.ToString();
            textBox_End_Reached.Text = Properties.Settings.Default.loop_FLG.ToString();
            Properties.Settings.Default.init_display_size = Math.Round(Properties.Settings.Default.init_display_size, 2);
            textBox_Display_Size.Text = Properties.Settings.Default.init_display_size.ToString();
            textBox_Default_Volume.Text = Properties.Settings.Default.init_sliderVolume_Value.ToString();
            textBox_dll_Path.Text = Properties.Settings.Default.libVlcDllsPath.ToString();
            textBox_plugin_path.Text = Properties.Settings.Default.libVlcPluginsPath.ToString();
        }

        private void Button_CANCEL_Click(object sender, EventArgs e)
        {
            Dispose();
        }

        private void Button_CANCEL_MouseClick(object sender, MouseEventArgs e)
        {
            Dispose();
        }

        private void Button_OK_MouseClick(object sender, MouseEventArgs e)
        {
            Save();
        }

        private void Button_OK_Click(object sender, EventArgs e)
        {
            Save();
        }

        private void Save()
        {
            try
            {
                //Input Check
                if (int.Parse(textBox_Window_mode.Text) != 0 && int.Parse(textBox_Window_mode.Text) != 1)
                {
                    MessageBox.Show("Input Error", "Check Border/NoBoder", MessageBoxButtons.OK,MessageBoxIcon.Error);
                    return;
                }
                                
                if(int.Parse(textBox_Stretch_Mode.Text) != 0 && int.Parse(textBox_Stretch_Mode.Text) != 1
                    && int.Parse(textBox_Stretch_Mode.Text) != 2 && int.Parse(textBox_Stretch_Mode.Text) != 3)
                {
                    MessageBox.Show("Input Error", "Check Stretch Mode", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    return;
                }
                
                if (int.Parse(textBox_Continue.Text) != 0 && int.Parse(textBox_Continue.Text) != 1
                    && int.Parse(textBox_Continue.Text) != 2)
                {
                    MessageBox.Show("Input Error", "Check Startup", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    return;
                }
                                
                if (double.Parse(textBox_Button_Visibility.Text) < 0 || double.Parse(textBox_Button_Visibility.Text) > 1)
                {
                    MessageBox.Show("Input Error", "Check Button Visibility", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    return;
                }
                
                if (int.Parse(textBox_Topmost.Text) != 0 && int.Parse(textBox_Topmost.Text) != 1)
                {
                    MessageBox.Show("Input Error", "Check Topmost", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    return;
                }
                                
                if (int.Parse(textBox_End_Reached.Text) != 0 && int.Parse(textBox_End_Reached.Text) != 1
                    && int.Parse(textBox_End_Reached.Text) != 2 && int.Parse(textBox_End_Reached.Text) != 3)
                {
                    MessageBox.Show("Input Error", "Check End Reached", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    return;
                }
                                
                if (double.Parse(textBox_Display_Size.Text) < 0 || double.Parse(textBox_Display_Size.Text) > 3)
                {
                    MessageBox.Show("Input Error", "Check Display Size", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    return;
                }

                if (double.Parse(textBox_Default_Volume.Text) < 0 || double.Parse(textBox_Default_Volume.Text) > 100)
                {
                    MessageBox.Show("Input Error", "Check Default Volume", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    return;
                }

                if (!Directory.Exists(textBox_dll_Path.Text))
                {
                    MessageBox.Show("Error 'Dll path' not exist. Correct  'Dll path'.", "Check Dll path", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    return;
                }
                if (!Directory.Exists(textBox_plugin_path.Text))
                {
                    MessageBox.Show("Error 'Plugin path' not exist. Correct  'Plugin path'.", "Check Plugin path", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    return;
                }

                //Save Parameter
                Properties.Settings.Default.AllowsTransparency_FLG = int.Parse(textBox_Window_mode.Text);
                Properties.Settings.Default.strech_FLG = int.Parse(textBox_Stretch_Mode.Text);
                Properties.Settings.Default.continue_FLG = int.Parse(textBox_Continue.Text);
                Properties.Settings.Default.init_visibility = double.Parse(textBox_Button_Visibility.Text);
                Properties.Settings.Default.topmost_FLG = int.Parse(textBox_Topmost.Text);
                Properties.Settings.Default.loop_FLG = int.Parse(textBox_End_Reached.Text);
                Properties.Settings.Default.init_display_size = Math.Round(double.Parse(textBox_Display_Size.Text), 2);
                Properties.Settings.Default.init_sliderVolume_Value = double.Parse(textBox_Default_Volume.Text);
                Properties.Settings.Default.libVlcDllsPath = textBox_dll_Path.Text;
                Properties.Settings.Default.libVlcPluginsPath = textBox_plugin_path.Text;
                Properties.Settings.Default.Save();
                //MessageBox.Show("Parameters Saved.", "Set Parameters",MessageBoxButtons.OK,MessageBoxIcon.Information);
                Dispose();
            }
            catch
            {
                MessageBox.Show("Input Error.", "Set Parameters", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }
    }
}
